<?php

require_once "phpfspot.class.php";

class PHPFSPOT_IMG {
   
   var $db;
   var $parent;

   public function __construct()
   {
      $this->parent = new PHPFSPOT;
      $this->db = $this->parent->db;

   } // __construct()

   public function __destruct()
   {

   } // __desctruct()

   public function show($idx, $width = 0)
   {
      $details = $this->parent->get_photo_details($idx);
   
      if(!$details) {
         $this->parent->showTextImage("The image you requested is unknown");
         return;
      }

      /* no width specified - show photo in its original size */
      if($width == 0) {
         $fullpath = $this->parent->translate_path($details['directory_path'])  ."/". $details['name'];
      }
      /* show thumbnail */
      else {
         /* if no entry for this photo is yet in the database, create thumb */
         if(!$this->parent->getMD5($idx)) {
            $this->parent->gen_thumb($idx);
         }
         $fullpath = $this->parent->cfg->base_path ."/thumbs/". $width ."_". $this->parent->getMD5($idx);
         /* if the thumb file does not exist, create it */
         if(!file_exists($fullpath)) {
            $this->parent->gen_thumb($idx);
         }
      }

      if(!file_exists($fullpath)) {
         $this->parent->showTextImage("File ". basename($fullpath) ." does not exist");
         return;
      }
      if(!is_readable($fullpath)) {
         $this->parent->showTextImage("File ". basename($fullpath) ." is not readable. Check the permissions");
         return;
      }

      $tmp = getimagesize($fullpath);
      $mime = $tmp['mime'];

      if(!$this->parent->checkifImageSupported($mime)) {
         $this->parent->showTextImage("Unsupported Image Type");
         return;
      }

      Header("Content-Type: ". $mime);
      Header("Content-Length: ". filesize($fullpath));
      Header("Content-Transfer-Encoding: binary\n");
      Header("Content-Disposition: inline; filename=\"". $details['name'] ."\"");
      Header("Accept-Ranges: bytes");
      Header("Connection: close");
   
      $file = fopen($fullpath, "rb");
      fpassthru($file);
      @fclose($file);

   } // show()

}

if(isset($_GET['idx']) && is_numeric($_GET['idx'])) {

   $img = new PHPFSPOT_IMG;

   if(isset($_GET['width']) && is_numeric($_GET['width'])) 
      $img->show($_GET['idx'], $_GET['width']);
   else
      $img->show($_GET['idx']);
}

?>
